# Code for "Beyond Linear Approximations: A Novel Pruning Approach for Attention Matrix"

### 1. Environment Setup

Install the dependencies by running the following command:

```
pip install -r requirements.txt
```

### 2. Evaluation
for each method, we provide 3 experiments:
* compare the loss when the regularization coefficient $\lambda$ is different.
* compare the loss when pruning ratio $\rho$ is different.
* compare the loss when the sequence length $n$ is different.

Run the following command to evaluate:
```
python main.py --run_gd_and_wanda=True --run_sparse_gpt=True
```
### 3.Rebuttal Code
please enter the rebuttal folder
```
cd 7932_supp_rebuttal
```
To run varying n experiment, please run
```
python rebuttal_varient_n.py
```

To run varying $\rho$ experiment, please run
```
python rebuttal_varient_rho.py
```